studentdb/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  devise_for :users
  get 'site/index'
  get 'site/admin_dashboard', as: :admin_dashboard
  resources :projects
  resources :students
  post 'projects/:id/students', as: :add_student_to_project, controller: :projects, action: :add_student
  root to: 'site#index'
end

studentdb/app/models/project.rb
# frozen_string_literal: true

# Project model class
class Project < ApplicationRecord
  validates_presence_of :name
  validates_uniqueness_of :name
  validates_presence_of :url
  has_many :project_students, dependent: :destroy
  has_many :students, through: :project_students
  accepts_nested_attributes_for :students, allow_destroy: true, reject_if: :reject_students

  def reject_students(attributes)
    if attributes['_destroy_r'].to_i != 0
      student = students.where(id: attributes['id'])
      students.destroy(student) if student
      student&.first&.destroy
      return true
    end
    attributes['studentid'].blank? and attributes['name'].blank?
  end

  def add_student(attributes)
    student = Student.find_or_create_by_studentid attributes[:studentid]
    errors[:students] << 'already has the requested student' and return false if students.include? student

    students.append student
  end
end

studentdb/app/controllers/projects_controller.rb
# frozen_string_literal: true

# Controller for the projects resource
class ProjectsController < ApplicationController
  before_action :authenticate_user!, except: %i[index show]
  before_action :set_project, only: %i[show edit update destroy add_student]

  # GET /projects or /projects.json
  def index
    @projects = Project.all
  end

  # GET /projects/1 or /projects/1.json
  def show; end

  # GET /projects/new
  def new
    authorize Project
    @project = Project.new
    @project.students.build
  end

  # GET /projects/1/edit
  def edit
    @project.students.build
  end

  # POST /projects or /projects.json
  def create
    @project = Project.new(project_params)
    respond_to do |format|
      if @project.save
        format.html { redirect_to @project, notice: 'Project was successfully created.' }
        format.json { render :show, status: :created, location: @project }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /projects/1 or /projects/1.json
  def update
    authorize @project
    respond_to do |format|
      if @project.update(project_params)
        format.html { redirect_to @project, notice: 'Project was successfully updated.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # POST /projects/:id/students

  def add_student
    authorize params[:student], :add_to_project?, policy_class: StudentPolicy
    respond_to do |format|
      if @project.add_student params[:student]
        format.html { redirect_to @project, notice: 'Student was successfully added.' }
        format.json { render :show, status: :ok, location: @project }
      else
        format.html { render :show, status: :unprocessable_entity }
        format.json { render json: @project.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /projects/1 or /projects/1.json
  def destroy
    @project.destroy
    respond_to do |format|
      format.html { redirect_to projects_url, notice: 'Project was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

  # Use callbacks to share common setup or constraints between actions.
  def set_project
    @project = Project.find(params[:id])
  end

  # Get list of IDs from students attributes
  def existing_student_ids(filtered_parms)
    filtered_parms[:students_attributes]&.values&.collect { |s| s[:id] }&.compact
  end

  # Only allow a list of trusted parameters through.
  def project_params
    filtered_params = params.require(:project).permit(policy(@project || Project).permitted_attributes)
    filtered_params[:student_ids] |= existing_student_ids(filtered_params)
    filtered_params
  end
end

studentdb/app/helpers/projects_helper.rb
# frozen_string_literal: true

# Helpers for projects controller
module ProjectsHelper
end

studentdb/app/views/projects/_form.html.erb
<%= form_with(model: project, local: true, class: 'row d-flex justify-content-center') do |form| %>
  <% if project.errors.any? %>
    <div id="error_explanation" class="mb-4 text-center">
      <h2><%= pluralize(project.errors.count, "error") %> prohibited this project from being saved:</h2>
      <ul>
        <% project.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="form-outline mb-4">
    <%= form.text_field :name, class: 'form-control' %>
    <%= form.label :name, class: 'form-label' %>
  </div>

  <div class="form-outline mb-4">
    <%= form.text_field :url, class: 'form-control' %>
    <%= form.label :url, class: 'form-label' %>
  </div>

  <%= form.submit class: 'btn btn-primary mb-4' %>

  <% if !project.new_record? %>
    <h5>Students</h5>
    <div id="existing-students-container" class="mb-4">
      <%= form.select :student_ids,
          options_for_select((Student.all - project.students).collect { |student| [student.name, student.id] }),
          {}, { multiple: true, id: "existing-students" } %>
    </div>
    <%= form.fields_for(:students) do |nested_form| %>
      <% if nested_form.object.new_record? %>
        <p class="mb-4">
          <%= link_to 'Add new student', '#new-student-form',
                      class: 'btn',
                      'data-mdb-toggle' => 'collapse',
                      role: 'button',
                      'aria-expanded' => 'false',
                      'aria-controls' => 'new-student-form' %>
        </p>
        <div class="collapse mt-3" id="new-student-form">
          <h6>New student</h6>
      <% else %>
        <% student_index = nested_form.options[:child_index] %>
        <div class="mt-3" id="student-<%= student_index %>-form">
          <h6>Current student
            <%= nested_form.check_box :_destroy, value: false, style: "display: none;" %>
            <%= nested_form.check_box :_destroy_r, value: false, style: "display: none;" %>
            <%= link_to '#', class: "destroy-student-link", data: { student_index: student_index } do %>
              <span title="Remove student from project"><i class="fa fa-user-slash"></i></span>
            <% end %>
            <%= link_to '#', class: "recursive-destroy-student-link", data: { student_index: student_index } do %>
              <span title="Destroy student"><i class="fa fa-trash"></i></span>
            <% end %>
          </h6>
      <% end %>
          <div class="form-outline mb-4">
            <%= nested_form.text_field :studentid, class: 'form-control' %>
            <%= nested_form.label :studentid, class: 'form-label' %>
          </div>
          <div class="form-outline mb-4">
            <%= nested_form.text_field :name, class: 'form-control' %>
            <%= nested_form.label :name, class: 'form-label' %>
          </div>
        </div>
    <% end %>
    <%= form.submit 'Update project students', class: 'btn btn-primary mb-4' %>
  <% end %>
<% end %>

studentdb/app/views/projects/edit.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">
        Edit Project
        <%= link_to project_path(@project) do %>
          <span title="Discard changes and show"><i class="fa fa-eye"></i></span>
        <% end %>
      </h4>
      <%= link_to projects_path do %>
        <h4 class="close"><span title="Close"><i class="fa fa-times"></i></span></h4>
      <% end %>
      <%= render 'form', project: @project %>
    </div>
  </div>
</div>

studentdb/app/views/projects/index.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">Projects</h4>
      <table class="table table-striped">
        <thead>
          <tr>
            <th>Name</th>
            <th>Url</th>
            <% if user_signed_in? %>
              <th colspan="3">Actions</th>
            <% else %>
              <th colspan="1"></th>
            <% end %>
          </tr>
        </thead>

        <tbody>
          <% @projects.each do |project| %>
            <tr>
              <td><%= project.name %></td>
              <td><%= project.url %></td>
              <td>
                <%= link_to project do %>
                  <span title="Show"><i class="fa fa-eye"></i></span>
                <% end %>
              </td>
              <% if user_signed_in? %>
                <td>
                  <%= link_to edit_project_path(project) do %>
                    <span title="Edit"><i class="fa fa-edit"></i></span>
                  <% end %>
                </td>
                <td>
                  <%= link_to project, method: :delete, data: { confirm: 'Are you sure?' } do %>
                    <span title="Delete"><i class="fa fa-trash"></i></span>
                  <% end %>
                </td>
              <% end %>
            </tr>
          <% end %>
        </tbody>
      </table>
      <% if user_signed_in? %>
        <%= link_to 'New Project', new_project_path, class: "btn btn-primary", role: "button" %>
      <% end %>
    </div>
  </div>
</div>

studentdb/app/views/projects/new.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">New Project</h4>
      <%= link_to projects_path do %>
        <h4 class="close"><span title="Close"><i class="fa fa-times"></i></span></h4>
      <% end %>
      <%= render 'form', project: @project %>
    </div>
  </div>
</div>

studentdb/app/views/projects/show.html.erb
<div class="col-md-4 offset-md-4">
  <div class="card">
    <div class="card-body">
      <h4 class="card-title">
        <%= @project.name %>
        <%= link_to edit_project_path(@project) do %>
          <span title="Edit"><i class="fa fa-edit"></i></span>
        <% end %>
      </h4>
      <%= link_to projects_path do %>
        <h4 class="close"><span title="Close"><i class="fa fa-times"></i></span></h4>
      <% end %>
      <p class="mb-4"><%= @project.url %></p>
      <h5>Students</h5>
      <% if @project.students.size > 0 %>
        <table class="table table-striped">
          <thead>
            <tr>
              <th>Name</th>
              <th>Student ID</th>
            </tr>
          </thead>
          <tbody>
            <% @project.students.each do |student| %>
              <tr>
                <td><%= link_to student.name, student_path(student) %></td>
                <td><%= student.studentid %></td>
              </tr>
            <% end %>
          </tbody>
        </table>
      <% else %>
        <p class="mb-4"><i>None added yet</i></p>
      <% end %>
      <% if current_user && current_user.is_student %>
        <%= link_to 'Add self to project', '#', class: "btn btn-primary",
                    role: "button", id: "add-self-to-project",
                    data: {
                      'path': add_student_to_project_path(@project, format: :json),
                      'student-id': current_user.studentid
                    } %>
      <% end %>
    </div>
  </div>
</div>